#include "messwert_zuordnung_dll.h"
#include <iostream>
#include <string>
#include <math.h>
#include <QDebug>
#include <QtCore/QCoreApplication>
#include <Windows.h>
#include <QtSerialPort/QSerialPort>
#include <QtCore/QDebug>
#include <QIODevice>

double interv_1 = (1/15);
double interv_2 = (1/30);
double interv_4 = (1/60);
double z = 62.5;
double messmeth=0;
double messint=1;
double abs_messungen=1;
double anz_messungen=1;
double radius=1;
double bauteillaenge=1;
double interpol=1;
double x;
QString error;

//Definieren der seriellen Schnittstelle.
QSerialPort *serial;





Messwert_Zuordnung_DLL::Messwert_Zuordnung_DLL()
{

}

void Messwert_Zuordnung_DLL::uebergabe(double messmeth, double messint, double bauteillaenge, double interpol, double anz_messungen, double abs_messungen)
{

    //Konfigurieren der seriellen Schnittstelle.

    serial = new QSerialPort();


    //+++++++++++++++++++++++++++++++++++
    //+++++++++++++++++++++++++++++++++++
    //Anpassen an zugewiesenen COM-Port !

    serial->setPortName("\COM12");

    //+++++++++++++++++++++++++++++++++++
    //+++++++++++++++++++++++++++++++++++


    serial->setBaudRate(QSerialPort::Baud115200);
    serial->setDataBits(QSerialPort::Data8);
    serial->setParity(QSerialPort::NoParity);
    serial->setStopBits(QSerialPort::OneStop);
    serial->setFlowControl(QSerialPort::SoftwareControl);


    serial->open(QIODevice::ReadWrite);
    qDebug()<< serial->errorString();


    if (!serial->open(QIODevice::ReadWrite)) {
        qDebug()<< "Serielle Schnittstelle kann nicht geöffnet werden!";

    }

    //Messmeth = 1 -> vertikale Linien messen wurde ausgewählt.
         if (messmeth == 1){


            //Konvertieren der eingelesenen Werte von QString in double zum senden.


            QByteArray messint_s = QByteArray::number(messint);
            QByteArray bauteillaenge_s = QByteArray::number(bauteillaenge);
            QByteArray interpol_s = QByteArray::number(interpol);
            QByteArray anz_messungen_s = QByteArray::number(anz_messungen);
            QByteArray abs_messungen_s = QByteArray::number(abs_messungen);

            //Senden der Variablen
            serial->write("1");
            serial->write("\n");

            serial->write(bauteillaenge_s);
            serial->write("\n");

            serial->write(messint_s);
            serial->write("\n");

            serial->write(interpol_s);
            serial->write("\n");

            serial->write(anz_messungen_s);
            serial->write("\n");

            serial->write(abs_messungen_s);
            serial->write("\n");







        }

        //Messmeth = 0 -> Umfang messen wurde ausgewählt.
        if (messmeth == 0){



            //Konvertieren der eingelesenen Werte von QString in double zum senden.

            QByteArray messint_s = QByteArray::number(messint);
            QByteArray bauteillaenge_s = QByteArray::number(bauteillaenge);
            QByteArray interpol_s = QByteArray::number(interpol);
            QByteArray anz_messungen_s = QByteArray::number(anz_messungen);
            QByteArray abs_messungen_s = QByteArray::number(abs_messungen);

            //Senden der Variablen
            serial->write("0");
            serial->write("\n");

            serial->write(messint_s);
            serial->write("\n");

            serial->write(bauteillaenge_s);
            serial->write("\n");

            serial->write(interpol_s);
            serial->write("\n");

            serial->write(anz_messungen_s);
            serial->write("\n");

            serial->write(abs_messungen_s);
            serial->write("\n");
        }

 serial->close();

}





